Package org.apache.commons.math3.analysis.solvers

# Class MullerSolver2

java.lang.Object
org.apache.commons.math3.analysis.solvers.BaseAbstractUnivariateSolver<UnivariateFunction>
org.apache.commons.math3.analysis.solvers.AbstractUnivariateSolver
org.apache.commons.math3.analysis.solvers.MullerSolver2

All Implemented Interfaces:
  `BaseUnivariateSolver<UnivariateFunction>`, `UnivariateSolver`

public class MullerSolver2 extends AbstractUnivariateSolver
This class implements the Muller's Method for root finding of real univariate functions. For reference, see Elementary Numerical Analysis, ISBN 0070124477, chapter 3.

Muller's method applies to both real and complex functions, but here we restrict ourselves to real functions. This class differs from `MullerSolver` in the way it avoids complex operations.

Except for the initial [min, max], it does not require bracketing condition, e.g. f(x0), f(x1), f(x2) can have the same sign. If a complex number arises in the computation, we simply use its modulus as a real approximation.

Because the interval may not be bracketing, the bisection alternative is not applicable here. However in practice our treatment usually works well, especially near real zeroes where the imaginary part of the complex approximation is often negligible.

The formulas here do not use divided differences directly.

Since:
  1.2
See Also:
  - `MullerSolver`

## Constructor Summary

Constructors
Constructor
Description
`MullerSolver2()`
Construct a solver with default accuracy (1e-6).
`MullerSolver2(double absoluteAccuracy)`
Construct a solver.
`MullerSolver2(double relativeAccuracy, double absoluteAccuracy)`
Construct a solver.

## Method Summary

Modifier and Type
Method
Description
`protected double`
`doSolve()`
Method for implementing actual optimization algorithms in derived classes.

### Methods inherited from class org.apache.commons.math3.analysis.solvers.BaseAbstractUnivariateSolver

`computeObjectiveValue, getAbsoluteAccuracy, getEvaluations, getFunctionValueAccuracy, getMax, getMaxEvaluations, getMin, getRelativeAccuracy, getStartValue, incrementEvaluationCount, isBracketing, isSequence, setup, solve, solve, solve, verifyBracketing, verifyInterval, verifySequence`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.commons.math3.analysis.solvers.BaseUnivariateSolver

`getAbsoluteAccuracy, getEvaluations, getFunctionValueAccuracy, getMaxEvaluations, getRelativeAccuracy, solve, solve, solve`

## Constructor Details

### MullerSolver2

public MullerSolver2()
Construct a solver with default accuracy (1e-6).

### MullerSolver2

public MullerSolver2(double absoluteAccuracy)
Construct a solver.

Parameters:
  `absoluteAccuracy` - Absolute accuracy.

### MullerSolver2

public MullerSolver2(double relativeAccuracy, double absoluteAccuracy)
Construct a solver.

Parameters:
  `relativeAccuracy` - Relative accuracy.
  `absoluteAccuracy` - Absolute accuracy.

## Method Details

### doSolve

protected double doSolve() throws TooManyEvaluationsException, NumberIsTooLargeException, NoBracketingException
Method for implementing actual optimization algorithms in derived classes.

Specified by:
  `doSolve` in class `BaseAbstractUnivariateSolver<UnivariateFunction>`
Returns:
  the root.
Throws:
  `TooManyEvaluationsException` - if the maximal number of evaluations is exceeded.
  `NoBracketingException` - if the initial search interval does not bracket a root and the solver requires it.
  `NumberIsTooLargeException`